/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author:  Ante Brkic <abrkic@linux.hr>
 * Contributors:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 */

#include <string.h>
#include <stdlib.h>

#include "si3d.h"

char *prgname = NULL;

#ifdef MSVC
void debug_message(char *msg)
{
	printf("%s:%i: %s\n", __FILE__, __LINE__, msg);
}
#endif

void cnv2dosfn(char *fname)
{
#ifdef DOS
	int i=0;
	while (fname[i]!='\0')
	{
		if (fname[i]=='/') fname[i]='\\';
		i++;
	}
#endif
}

int
main (int argc, char *argv[])
{
  int r;
  long int br, br1;
  double trosi, pomak;
  int flag = 0;
  DIALOG out_menu[] = {
    {d_button, 70, 180, 160, 40, 0, 0, 0, 0, 0, 0,
		 "CONTINUE", NULL, NULL},
    {d_button, 70, 220, 160, 40, 0, 0, 0, 0, 0, 0,
		 "SAVE GAME", NULL, NULL},
    {d_button, 70, 260, 160, 40, 0, 0, 0, 0, 0, 0,
		 "SAVE SCREENSHOT", NULL, NULL},
    {d_button, 70, 300, 160, 40, 0, 0, 0, 0, 0, 0,
		 "SAVE MAP", NULL, NULL},
    {d_button, 70, 360, 160, 40, 0, 0, 0, 0, 0, 0,
		 "END GAME", NULL, NULL},
    {NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		 NULL, NULL, NULL}
  };

  argc = argc;			/* To kill the `argc is not used' warning. */
  prgname = argv[0];
  intro ();
  printf ("Initializing...\n");
  inicijalizacija ();
  
  uvodni_izbor ();
  do
	{
		if (keypressed ())
		{
			switch (readkey () >> 8)
	    {
			case KEY_H:
				blit(screen,za_monitor,0,0,0,0,SCREEN_W,SCREEN_H);
				help();
				blit(za_monitor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
				break;

			case KEY_S:
				if (play_sound) {
					debug_message("Sound off");
					play_sound = 0;
				} else {
					debug_message("Sound on");
					play_sound = 1;
				}
				break;

			case KEY_F1:
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (-1);

				debug_message("rotate view 90' left");

	      ma_daj_okreni (1);
	      iscrtaj_reljef (1, 0, 640, 0, 640);
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (1);
	      break;

	    case KEY_F2:
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (-1);

				debug_message("rotate view 90' right");

	      ma_daj_okreni (2);
	      iscrtaj_reljef (1, 0, 640, 0, 640);
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (1);
	      break;

	    case KEY_ESC:
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (-1);
	      do
				{
					blit(background[0].dat, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
					switch (r = do_dialog(out_menu,0)) {
					case 0:
						r = -1;
						aktivni = pogled;
						blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
						aktivni = za_monitor;
						crtaj_tenk (igrac);
						blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
						if (vidljivo_sucelje == 1)
							crtaj_sucelje (1);
						break;
					case 1:
						r = 100;
						break;
					case 2:
						snimi_sliku ();
						break;
					case 3:
						snimi_kartu ();
						break;
					case 4:
						uvodni_izbor ();
						r = -1;
						break;
					}
	      } while (r > 0);
	      flag = 0;
	      break;

	    case KEY_HOME:
	      tenk[igrac].kut += 0.02;
	      if (tenk[igrac].kut > 2 * PI)
					tenk[igrac].kut = 0;
	      flag = 1;
	      clear_keybuf();
	      break;

	    case KEY_INSERT:
	      tenk[igrac].kut -= 0.02;
	      if (tenk[igrac].kut < 0.02)
					tenk[igrac].kut = 2 * PI;
	      flag = 1;
	      clear_keybuf();
	      break;

	    case KEY_RIGHT:
	      tenk[igrac].kut += 0.2;
	      if (tenk[igrac].kut > 2 * PI)
					tenk[igrac].kut = 0;
	      flag = 1;
				clear_keybuf();
	      break;

	    case KEY_LEFT:
	      tenk[igrac].kut -= 0.2;
	      if (tenk[igrac].kut < 0.02)
					tenk[igrac].kut = 2 * PI;
	      flag = 1;
				clear_keybuf();
	      break;

	    case KEY_DOWN:
	      if (
					(reljef[(int) (tenk[igrac].x - cos (tenk[igrac].kut) * 2)]
					 [(int) (tenk[igrac].y - sin (tenk[igrac].kut) * 2)].vis >
					 0) && (tenk[igrac].x - cos (tenk[igrac].kut) * 2 > 0)
					&& (tenk[igrac].x - cos (tenk[igrac].kut) * 2 < 640)
					&& (tenk[igrac].y - sin (tenk[igrac].kut) * 2 > 0)
					&& (tenk[igrac].y - sin (tenk[igrac].kut) * 2 < 640)
					&& (tenk[igrac].mp >= 1))
				{
					trosi =
						-(reljef
							[(int) (tenk[igrac].x + cos (tenk[igrac].kut) * 10)][
								(int)
								(tenk
								 [igrac].
								 y
								 +
								 sin
								 (tenk
									[igrac].
									kut)
								 *
								 10)].
							vis -
							reljef[(int)
										(tenk[igrac].x -
										 cos (tenk[igrac].kut) *
										 10)][(int) (tenk[igrac].y -
																 sin (tenk[igrac].kut) * 10)].vis) /
						10;
					provjera_dodira ();
					if (trosi < 0)
						trosi = 0;
					if (trosi < 4)
					{
						tenk[igrac].mp -= 0.05;
						pomak = 2 - sqrt (trosi);
						tenk[igrac].x -= cos (tenk[igrac].kut) * pomak;
						tenk[igrac].y -= sin (tenk[igrac].kut) * pomak;
						provjera_dodira ();
						if (kontrola == 0)
						{
							tenk[igrac].x += cos (tenk[igrac].kut) * pomak;
							tenk[igrac].y += sin (tenk[igrac].kut) * pomak;
						}
					}
				}
	      baci_smece ();
	      flag = 1;
				clear_keybuf();
	      break;

	    case KEY_UP:
	      if (
					(reljef[(int) (tenk[igrac].x + cos (tenk[igrac].kut) * 2)]
					 [(int) (tenk[igrac].y + sin (tenk[igrac].kut) * 2)].vis >
					 0) && (tenk[igrac].x + cos (tenk[igrac].kut) * 2 > 0)
					&& (tenk[igrac].x + cos (tenk[igrac].kut) * 2 < 640)
					&& (tenk[igrac].y + sin (tenk[igrac].kut) * 2 > 0)
					&& (tenk[igrac].y + sin (tenk[igrac].kut) * 2 < 640)
					&& (tenk[igrac].mp >= 1))
				{
					trosi =
						(reljef
						 [(int) (tenk[igrac].x + cos (tenk[igrac].kut) * 10)][
							 (int)
							 (tenk
								[igrac].
								y +
								sin
								(tenk
								 [igrac].
								 kut)
								*
								10)].
						 vis -
						 reljef[(int)
									 (tenk[igrac].x -
										cos (tenk[igrac].kut) *
										10)][(int) (tenk[igrac].y -
																sin (tenk[igrac].kut) * 10)].vis) /
						10;
					if (trosi < 0)
						trosi = 0;
					if (trosi < 4)
					{
						tenk[igrac].mp -= 0.05;
						pomak = 2 - sqrt (trosi);
						tenk[igrac].x += cos (tenk[igrac].kut) * pomak;
						tenk[igrac].y += sin (tenk[igrac].kut) * pomak;
						provjera_dodira ();
						if (kontrola == 0)
						{
							tenk[igrac].x -= cos (tenk[igrac].kut) * pomak;
							tenk[igrac].y -= sin (tenk[igrac].kut) * pomak;
						}
					}
				}
	      baci_smece ();
	      flag = 1;
				clear_keybuf();
	      break;

	    case KEY_PGUP:
	      if (tenk[igrac].kut_cijevi * 180 / PI > 0.02)
				{
					tenk[igrac].kut_cijevi -= 0.01;
					flag = 1;
					clear_keybuf();
				}
	      break;

			case KEY_PGDN:
	      if (tenk[igrac].kut_cijevi * 180 / PI < 85.08)
				{
					tenk[igrac].kut_cijevi += 0.01;
					flag = 1;
					clear_keybuf();
				}
	      break;
/*provjera flag==1 premjestena van case-a*/
	    case KEY_SPACE:
	      if ((tenk[igrac].aktivno_oruzje < 2 ||
						 tenk[igrac].w[tenk[igrac].aktivno_oruzje] > 0) &&
						(tenk[igrac].ap >=
						 oruzje[tenk[igrac].aktivno_oruzje].trosi_ap))
				{
					if (tenk[igrac].aktivno_oruzje != 5 &&
							tenk[igrac].aktivno_oruzje != 9 &&
							tenk[igrac].aktivno_oruzje != 10)
					{
						if (vidljivo_sucelje == 1)
							crtaj_sucelje (-1);
						baci_projektil ();
						/* if (kontrola == 0) */
						{
							ispisi_sucelje (1);
							if (vidljivo_sucelje == 1)
								crtaj_sucelje (1);
						}
						/* kontrola = 0; */
					}
				}
	      break;

	    case KEY_TAB:
				if (key_shifts == KB_SHIFT_FLAG)
				{
					tenk[igrac].aktivno_oruzje--;
					if (tenk[igrac].aktivno_oruzje < 0)
						tenk[igrac].aktivno_oruzje = 10;
				}
	      else
				{
					tenk[igrac].aktivno_oruzje++;
					if (tenk[igrac].aktivno_oruzje > 10)
						tenk[igrac].aktivno_oruzje = 0;
				}
	      ispisi_sucelje (0);
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (0);
				aktivni = za_monitor;
				blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	      for (br = 0; br < 10000; br++)
				{
					for (br1 = 0; br1 < 500; br1++)
						;
				}
	      break;

	    case KEY_END:			/* KEY_E is less error-prone than KEY_END */
	    case KEY_E:
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (-1);
	      end_turn ();
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (1);
				aktivni = monitor;
	      for (br = 0; br < broj_igraca; br++)
				{
					if (tenk[br].energija >= 70)
						boja_fonta = makecol(20, 20 + tenk[br].energija, 20);
					if (tenk[br].energija < 70 && tenk[br].energija >= 10)
						boja_fonta = makecol (20 + tenk[br].energija, 20 + tenk[br].energija, 10);
					if (tenk[br].energija < 10 && tenk[br].energija > 0)
						boja_fonta = makecol (30 + tenk[br].energija, 30 + tenk[br].energija, 30);
					if (tenk[br].energija < 1)
						boja_fonta = makecol(5, 5, 5);
					textprintf(aktivni, font, tenk[br].x - 12,
										 123 - tenk[br].z + tenk[br].y / 2, boja_fonta, "%i",
										 (int) tenk[br].energija);
					boja_fonta = makecol(tenk[br].stit + 100,tenk[br].stit + 100, 20);
					if (tenk[br].stit > 0)
						textprintf(aktivni, font, tenk[br].x - 12,
											 110 - tenk[br].z + tenk[br].y / 2, boja_fonta, "%i",
											 (int) tenk[br].stit);
					if (igrac == br)
						circle (aktivni,tenk[br].x, 150 - tenk[br].z + tenk[br].y / 2,
										30, makecol (100, 100, 100));	
				}
	      for (br = 0; br < 10000; br++)
				{
					for (br1 = 0; br1 < 3000; br1++)
						;
				}
				aktivni = za_monitor;
	      crtaj_tenk (igrac);
				blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	      break;

	    case KEY_BACKSPACE:
	      vidljivo_sucelje = -vidljivo_sucelje;
				aktivni = pogled;
				blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
				aktivni = za_monitor;
	      crtaj_tenk (igrac);
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (1);
	      if (vidljivo_sucelje == -1)
					crtaj_sucelje (-1);
				blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	      break;

	    case KEY_I:
				aktivni = monitor;
	      for (br = 0; br < broj_igraca; br++)
				{
					if (tenk[br].energija >= 70)
						boja_fonta = makecol(20, 20 + tenk[br].energija,20);
					if (tenk[br].energija < 70 && tenk[br].energija >= 10)
						boja_fonta = makecol(20 + tenk[br].energija,20 + tenk[br].energija,10);
					if (tenk[br].energija < 10 && tenk[br].energija > 0)
						boja_fonta = makecol( 30 + tenk[br].energija,30 + tenk[br].energija,30 + tenk[br].energija);
					if (tenk[br].energija < 1)
						boja_fonta = makecol(5,5,5);
					textprintf(aktivni, font, tenk[br].x - 12,
										 123 - tenk[br].z + tenk[br].y / 2, boja_fonta, "%i",
										 (int) tenk[br].energija);
					boja_fonta = makecol(tenk[br].stit + 100,tenk[br].stit + 100,20);
					if (tenk[br].stit > 0)
						textprintf(aktivni, font, tenk[br].x - 12,
											 110 - tenk[br].z + tenk[br].y / 2, boja_fonta, "%i",
											 (int) tenk[br].stit);
					if (igrac == br)
						circle (aktivni,tenk[br].x, 150 - tenk[br].z + tenk[br].y / 2,
										30, makecol (100, 100, 100));	
				}
	      for (br = 0; br < 10000; br++)
				{
					for (br1 = 0; br1 < 5000; br1++)
						;
				}
				aktivni = za_monitor;
	      crtaj_tenk (igrac);
				blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	      break;
	    }			/*switch */
			if (flag == 1)
	    {
	      flag = 0;
	      ispisi_sucelje (0);
				aktivni = pogled;
				blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
				aktivni = za_monitor;
	      crtaj_tenk (igrac);
	      if (vidljivo_sucelje == 1)
					crtaj_sucelje (0);
				blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	    }
		}			/*keypressed */
	}
  while (1);
}

END_OF_MAIN();


FILE *
myopen (char *fname, char *mode)
{
  static int first = 1;
  /* The first `""' is just a placeholder for
   * the directory extracted from `argv[0]'.
   */
  static char *dirs[] = { "ENV", DIR, "MYDIR", ".", NULL };
  char tmp[1024], *c, *env;
  FILE *fp = NULL;
  int i;

	fname = strdup (fname);
	cnv2dosfn (fname);

  if ((prgname != NULL) && (first != 0))
	{
		c = (char *) (prgname + strlen (prgname) - 1);
		while ((*c != '/') && (*c != '\\') && (strlen (prgname) > 0))
			*(c--) = '\0';
		while (((*c == '/') || (*c == '\\')) && (strlen (prgname) > 0))
			*(c--) = '\0';
		first = 0;
	}
  env = getenv ("SI3D_DIR");
  for (i = 0; dirs[i] != NULL; i++)
	{
		if (strcmp (dirs[i], "MYDIR") == 0)
		{
			if (prgname == NULL)
				continue;
			dirs[i] = prgname;
		}
		else if (strcmp (dirs[i], "ENV") == 0)
		{
			if (env == NULL)
				continue;
			dirs[i] = env;
		}
		memset (tmp, 0, sizeof (tmp));
		strcpy (tmp, dirs[i]);
		strcat (tmp, "/");
		strcat (tmp, fname);
		fp = fopen (tmp, mode);
		if (fp != NULL)
			break;
	}
  if (fp == NULL)
	{
		printf ("ERROR: cannot open `%s'!\n", fname);
		exit (-1);
	}

	free (fname);
  return fp;
}

void
set_datafile_name()
{
  FILE *fd = NULL;
  /* The first `""' is just a placeholder for
   * the directory extracted from `argv[0]'.
   */
  static char *dirs[] = { "ENV", DIR, "MYDIR", ".", NULL };
  char *env, *fname;
  int i;

	fname = "si3d.dat";
	env = getenv ("SI3D_DIR");
  for (i = 0; dirs[i] != NULL; i++)
		{
			if (strcmp (dirs[i], "MYDIR") == 0)
				{
					if (prgname == NULL)
						continue;
					dirs[i] = prgname;
				}
			else if (strcmp (dirs[i], "ENV") == 0)
				{
					if (env == NULL)
						continue;
					dirs[i] = env;
				}
			if(datafile_name) free(datafile_name);

			datafile_name = malloc(1024);
			datafile_name = strcpy (datafile_name, dirs[i]);
			datafile_name = strcat (datafile_name, "/");
			datafile_name = strcat (datafile_name, fname);
			fd = fopen(datafile_name, "r");
			debug_message(datafile_name);
			if (fd != NULL)
				break;
		}
  if (fd == NULL)
		{
			printf ("ERROR: cannot open `%s'!\n", fname);
			exit (-1);
		} else {
			debug_message(datafile_name);
		}
	debug_message(datafile_name);
	if(fd) fclose(fd);
}

DATAFILE *
load(char *name)
{
	DATAFILE *df=NULL;

#ifdef DEBUG
	printf("Loading datafile object %s\n", name);
#endif /* DEBUG */

	df = load_datafile_object(datafile_name, name);
	if(!df) {
		printf("Error loading object %s!\n", name);
		exit(8);
	}
	return(df);
}

void
unload(DATAFILE *datafile)
{
	unload_datafile_object(datafile);
}
