/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Robert Avilov <ravilov@linux.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 */

#include <stdlib.h>

#include "si3d.h"

void
pocetne_vrijednosti (void)
{
  int br;
  time_t t;

  time (&t);
  srand (t);
  broj_pogleda = 1;		/* pogled od napred */
  kut_svjetlosti = -20 * PI / 180;
  vidljivo_sucelje = 1;
  broj_runde = 1;
  broj_turna = 1;
  broj_poklona = 0;
  kut_vjetra = 6.2832 * rand () / (RAND_MAX + 1.0);
  gen = 0;
  for (br = 0; br < 128; br++)
    {
      tenk[br].broj_pobjeda = 0;
      tenk[br].ukupna_steta = 0;
      tenk[br].mrtav = 0;
    }
}

void
inicijalizacija ()
{
#ifdef DEBUG
	if (getenv("MALLOC_TRACE") != NULL)
	{
		debug_message("start malloc trace");
		mtrace();
	} else {
		debug_message("env variable MALLOC_TRACE is not set");
		debug_message("  malloc is not traced");
	}
#endif
	
  allegro_init ();

  debug_message ("alleg init");
  
  install_keyboard ();
  debug_message ("keyboard installed");

	install_timer();
  debug_message ("timer installed");

	reserve_voices(2,0);

	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL)) {
		allegro_message("Error initialising sound system%s\n", allegro_error);
		have_sound = 0;
		play_sound = 0;
	} else {
		have_sound = 1;
		play_sound = 1;
		debug_message ("sound initialized");
		printf("Sound driver: %s\n", digi_driver->name);
	}

	set_datafile_name();

	set_color_depth (16);

  debug_message ("color depth: 16");

#ifdef DEBUG 
  if (set_gfx_mode (GFX_XWINDOWS, 640, 480, 0, 0) != 0) {
		printf("set_gfx_mode 640x480 failed!");
		exit(1);
  }
#else /* RELEASE */
  if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 0, 0) != 0) {
		printf("set_gfx_mode 640x480 failed!");
		exit(1);
  }
#endif /*DEBUG*/
  
  debug_message ("gfx mode 640x480");
  
  initted = 1;

	monitor = screen;
	aktivni = monitor;

  za_monitor = create_bitmap (640, 480);

  pogled = create_bitmap (640, 480);

  suc = create_bitmap (640, 60);

  slika_suc = create_bitmap (640, 60);

  small_health = create_bitmap(15,15);
  big_health = create_bitmap(20,20);
  shield = create_bitmap(12,20);
  ap = create_bitmap(12,12);
  mp = create_bitmap(12,12);
  weapon = create_bitmap(20,20);

  explosion = load("EXPLOSION");
	fire = load("FIRE");
	background = load("BGROUND");

  iskon ();
  help();
	init_talk ();
}

void
iskon (void)
{
  broj_teams = 2;
  broj_team_size = 1;
  broj_igraca = broj_teams * broj_team_size;
  igrac = 0;
  jacina_vjetra = 1;
  promjena_vjetra = 1;
  max_broj_rundi = 3;
  oruzje[0].trosi_ap = 2;
  oruzje[1].trosi_ap = 3;
  oruzje[2].trosi_ap = 5;
  oruzje[3].trosi_ap = 6;
  oruzje[4].trosi_ap = 8;
  oruzje[5].trosi_ap = 10;
  oruzje[6].trosi_ap = 5;
  oruzje[7].trosi_ap = 15;
  oruzje[8].trosi_ap = 1;
  oruzje[9].trosi_ap = 5;
  oruzje[10].trosi_ap = 5;
  oruzje[0].radijus = 0;
  oruzje[1].radijus = 15;
  oruzje[2].radijus = 25;
  oruzje[3].radijus = 50;
  oruzje[4].radijus = 10;
  oruzje[5].radijus = 15;
  oruzje[6].radijus = 35;
  oruzje[7].radijus = 25;
  oruzje[8].radijus = 30;
  oruzje[9].radijus = 0;
  oruzje[10].radijus = 0;
  oruzje[0].jacina = 0;
  oruzje[1].jacina = 4;
  oruzje[2].jacina = 5;
  oruzje[3].jacina = 0.05;
  oruzje[4].jacina = 10;
  oruzje[5].jacina = 4;
  oruzje[6].jacina = 0.03;
  oruzje[7].jacina = 0.5;
  oruzje[8].jacina = 5;
  oruzje[9].jacina = 0;
  oruzje[10].jacina = 0;
}
