/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Ante Brkic <abrkic@linux.hr>
 * Contributors:
 *         Vlatko Kosturjak <kost@iname.com>
 *         Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *         Dario Lah <dlah@foi.hr>
 */

#include "si3d.h"

int initted;

void
outro (void)
{

#ifdef BACKTEXT
  if (initted != 0)
  {
  	set_gfx_mode(GFX_TEXT,0,0,0,0);
  }
#endif

	/*unload(fire);
	unload(explosion);
	unload(background);*/

	if(datafile_name) free(datafile_name);

  	allegro_exit();
	
	printf ("Shutting down...\n");
	free(talk_buffer_kill);
	debug_message("free mem: talk_buffer_kill");
	free(talk_buffer_die);
	debug_message("free mem: talk_buffer_die");

#ifdef DEBUG
	if(getenv("MALLOC_TRACE") != NULL)
	{
		debug_message("stop malloc trace");
		muntrace();
	}
#endif
}

void
intro (void)
{
  printf ("Scorched Island 3D v" VERSION ". Distributed under GPL\n\n");
  atexit (outro);
}

void
help(){
    int y=0;

	char *helptext[]={"Scorched Island 3D " VERSION " - HELP",
	"",
	"LEFT              rotate left",
	"RIGHT             rotate right",
	"INSERT            fine rotate left",
	"HOME              fine rotate right",
	"UP                move forward",
	"DOWN              move backward",
	"PAGEUP            angle of fire up",
	"PAGEDOWN          angle of fire down",
	"TAB               next weapon",
	"TAB + SHIFT       previous weapon",
	"SPACE             fire",
	"END               end turn",
	"E                 end turn",
	"F1                rotate view left",
	"F2                rotate view right",
	"I                 energy/shield info",
	"BACKSPACE         show/hide interface",
  "s                 sound on/off",
	"ESC               menu",
	"h                 this help",
	"",
	"If you are running under Linux/X - please",
	"use 16 bpp color depth (it's optimized for that!)",
	"",
	"How to contact us?",
	"http://cvs.linux.hr/si3d/ or si3d@cvs.linux.hr"};

	rectfill (screen,5,5,635,475,makecol(155,155,155));
	rectfill (screen,10,10,630,470,makecol(0,0,0));

	for (y=0;y<26;y++)
	{
		textout (screen,font,helptext[y],50,50+y*(text_height(font)+5), makecol (255,255,255));
	}
    
    y = readkey();
}
