/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Robert Avilov <ravilov@linux.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 */

#include "si3d.h"
#include <string.h>

void
ucitaj_kartu (int level)
{
  int w, h, br, br1, flag;
  double kvocjent = 0, razlika = 0, udaljenost;
  time_t t;
	unsigned char *map;

  data ();
  aktivni = monitor;
  
  boja_fonta = makecol(255,255,255);
  
  textprintf(aktivni, font,70, 430,boja_fonta,"LOADING MAP");
  

	switch(level) {
	case 1:
		graphics = load("LEVEL1_MAP");
		nivo = 1;
		kvocjent = 1;
		razlika = 0;
		break;
	case 2:
		graphics = load("LEVEL2_MAP");
		nivo = 2;
		kvocjent = 1;
		razlika = -30;
		break;
	case 3:
	graphics = load("LEVEL3_MAP");
		nivo = 3;
		kvocjent = 1.8;
		razlika = 40;
		break;
	case 4:
	graphics = load("LEVEL4_MAP");
		nivo = 4;
		kvocjent = 1;
		razlika = 30;
		break;
	case 5:
	graphics = load("LEVEL5_MAP");
		nivo = 5;
		kvocjent = 1;
		razlika = 0;
		break;
	}

	map = graphics[0].dat;
  for (h = 0; h < 640; h++)
    for (w = 0; w < 640; w++){
			reljef[w][h].vis = *map++ / kvocjent - 55 + razlika;
		}
	unload(graphics);  

  ucitaj_teksture ();

  for (br = 0; br < broj_igraca; br++)
		{
			time (&t);
			srand (t);
			do
				{
					flag = 1;
					tenk[br].x = 50 + (int) (590.0 * rand () / (RAND_MAX + 50.0));
					tenk[br].y = 50 + (int) (590.0 * rand () / (RAND_MAX + 50.0));
					if (reljef[(int) tenk[br].x][(int) tenk[br].y].vis < 3)
						flag = 0;
					for (br1 = 0; br1 < broj_igraca; br1++)
						if (br1 != br)
							{
								udaljenost =
									sqrt ((tenk[br].x - tenk[br1].x) *
												(tenk[br].x - tenk[br1].x) + (tenk[br].y -
																											tenk[br1].y) *
												(tenk[br].y - tenk[br1].y));
								if (udaljenost < 30)
									flag = 0;
							}
				}
			while (flag == 0);
		}

  iscrtaj_reljef (0, 0, 640, 0, 640);
}

Tenk
tenk_new_by_broj (broj)
{
	Tenk def_tenk[4];
	char *tenk_ime[] = {"Red", "Blue", "Yellow", "Green"};
	int i;
	int w[11] = { 0, 0, 5, 5, 5, 0, 5, 5, 5, 0, 0 };

	def_tenk[broj].ime = strdup (tenk_ime[broj]);
	def_tenk[broj].broj = broj;
  def_tenk[broj].flag = 1;
  def_tenk[broj].kut_cijevi = 45 * PI / 180;
  def_tenk[broj].energija = 100;
  def_tenk[broj].stit = 0;
  def_tenk[broj].ap = 0;
  def_tenk[broj].mp = 0;
  def_tenk[broj].aktivno_oruzje = 0;
	
	def_tenk[broj].w = (int *) malloc (sizeof (int) * 11);
	for (i = 0; i < 11; i++)
		def_tenk[broj].w[i] = w[i];
	
  def_tenk[0].x = 220;
  def_tenk[0].y = 320;
  def_tenk[0].kut = 0;
  def_tenk[0].r = 200;
  def_tenk[0].g = 20;
  def_tenk[0].b = 30;

  def_tenk[1].x = 420;
  def_tenk[1].y = 320;
  def_tenk[1].kut = PI / 2;
  def_tenk[1].r = 30;
  def_tenk[1].g = 20;
  def_tenk[1].b = 200;

  def_tenk[2].x = 320;
  def_tenk[2].y = 220;
  def_tenk[2].kut = PI;
  def_tenk[2].r = 200;
  def_tenk[2].g = 200;
  def_tenk[2].b = 20;
	
  def_tenk[3].x = 320;
  def_tenk[3].y = 420;
  def_tenk[3].kut = 3 * PI / 2;
  def_tenk[3].r = 20;
  def_tenk[3].g = 200;
  def_tenk[3].b = 20;

	return def_tenk[broj];
}

void
tenk_new (int broj)
{
	int i;

	for (i = 0; i < 128 && tenk[i].flag; i++)
		;

	if (i < 128)
		tenk[i] = tenk_new_by_broj (broj);
}

void
data (void)
{
  int br, br1, i;
	int team, broj;
  time_t t;

	for (i = 0; i < 128; i++)
		tenk[i].flag = 0;

	for (broj = 0; broj < broj_team_size; broj++)
		for (team = 0; team < broj_teams; team++)
			tenk_new (team);
	
  time (&t);
  srand (t);
  broj_pogleda = 1;		/* pogled od napred */
  kut_svjetlosti = -20 * PI / 180;
  igrac = 0;
  vidljivo_sucelje = 1;
  broj_turna = 1;
  broj_poklona = 0;
  igrac = (int) (broj_igraca * 1.0 * rand () / (RAND_MAX + 1.0));
  tenk[igrac].mp += 10;
  for (br = 0; br < 5; br++)
    tenk[br].mrtav = 0;
  for (br = 0; br < 640; br++)
		{
			for (br1 = 0; br1 < 640; br1++)
				reljef[br][br1].sjena = 0;
		}
}

void
napravi_kartu (void)
{
  int w, h;
  int x[MAX_BROJ_VRHOVA], y[MAX_BROJ_VRHOVA], visina[MAX_BROJ_VRHOVA];
  double udaljenost;
  int pom = 0;
  int br, br1, flag;
  time_t t;

  gen = 1;

  data ();
  aktivni = za_monitor;
  
  boja_fonta = makecol(255,255,255);
  
  textprintf(aktivni,font, 70,430, boja_fonta, "GENERATING");
  
  blit(aktivni, monitor, 0,0,0,0, SCREEN_W, SCREEN_H);
  

  time (&t);
  srand (t);

  nivo = 1 + (int) (5.0 * rand () / (RAND_MAX + 1.0));

  for (br = 0; br < BROJ_VRHOVA; br++)
		{
			x[br] = 80 + (int) (480.0 * rand () / (RAND_MAX + 80.0));
			y[br] = 80 + (int) (480.0 * rand () / (RAND_MAX + 80.0));
			visina[br] = 100 + (int) (150.0 * rand () / (RAND_MAX + 100.0));
		}

  for (w = 0; w < 640; w++)
    for (h = 0; h < 640; h++)
      reljef[w][h].vis = 0;

  for (w = 0; w < 50; w++)
    for (h = w; h < 640 - w; h++)
			{
				reljef[w][h].vis = -(50 - w);
				reljef[h][w].vis = -(50 - w);
			}
  for (w = 590; w < 640; w++)
    for (h = 50 - (w - 590); h < w + 1; h++)
			{
				reljef[w][h].vis = -(w - 590);
				reljef[h][w].vis = -(w - 590);
			}

  aktivni = monitor;
  
  for (br = 0; br < BROJ_VRHOVA; br++)
    for (w = 0; w < 640; w++)
      for (h = 0; h < 640; h++)
				{
					udaljenost = hypot ((w - x[br]), (h - y[br]));
					if (udaljenost == 0)
						udaljenost = 1;

					if (udaljenost < SIRINA_VRHA)
						pom = visina[br];
					if (udaljenost >= SIRINA_VRHA && udaljenost < SIRINA_BRDA)
						{
							pom = (int) (visina[br] - sqrt (udaljenost - SIRINA_VRHA) * 20);
						}
					if (udaljenost >= SIRINA_BRDA)
						{
							pom =
								(int) (visina[br] - sqrt (SIRINA_BRDA - SIRINA_VRHA) * 20 -
											 sqrt (udaljenost - SIRINA_BRDA) * 5);
						}


					reljef[w][h].vis += pom;
					if (reljef[w][h].vis > MAX_VISINA_VRHA)
						reljef[w][h].vis = MAX_VISINA_VRHA;
					if (reljef[w][h].vis < -55)
						reljef[w][h].vis = -55;
				}

  ucitaj_teksture ();

  while (reljef[100][100].vis < 0 && reljef[540][100].vis < 0
				 && reljef[100][540].vis < 0 && reljef[540][540].vis < 0)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					reljef[br][br1].vis += 20;
		}

  while (reljef[10][10].vis > 0 || reljef[630][10].vis > 0
				 || reljef[10][630].vis > 0 || reljef[630][630].vis > 0)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					reljef[br][br1].vis -= 20;
		}

  for (br = 0; br < broj_igraca; br++)
		{
			time (&t);
			srand (t);
			do
				{
					flag = 1;
					tenk[br].x = 50 + (int) (590.0 * rand () / (RAND_MAX + 50.0));
					tenk[br].y = 50 + (int) (590.0 * rand () / (RAND_MAX + 50.0));
					if (reljef[(int) tenk[br].x][(int) tenk[br].y].vis < 3)
						flag = 0;
					for (br1 = 0; br1 < broj_igraca; br1++)
						if (br1 != br)
							{
								udaljenost =
									sqrt ((tenk[br].x - tenk[br1].x) *
												(tenk[br].x - tenk[br1].x) + (tenk[br].y -
																											tenk[br1].y) *
												(tenk[br].y - tenk[br1].y));
								if (udaljenost < 30)
									flag = 0;
							}
				}
			while (flag == 0);
		}

  iscrtaj_reljef (0, 0, 640, 0, 640);
}

void
ucitaj_teksture ()
{
  int w, h;
  int gamma_kopno = 0, gamma_more = 0;
  char *land, *sea;

	sirina_teksture_kopna = 100;
	visina_teksture_kopna = 100;
	sirina_teksture_mora = 50;
	visina_teksture_mora = 50;
	land=NULL;
	sea=NULL;

	switch(nivo) {
	case 1:
			sea = "LEVEL1_SEA";
			land = "LEVEL1_LAND";
			gamma_kopno = 0;
			gamma_more = 0;
			break;
	case 2:
			sea = "LEVEL2_SEA";
			land = "LEVEL2_LAND";
			gamma_kopno = -100;
			gamma_more = 70;
			break;
	case 3:
			sea = "LEVEL3_SEA";
			land = "LEVEL3_LAND";
			gamma_kopno = -20;
			gamma_more = 55;
			break;
	case 4:
			sea = "LEVEL4_SEA";
			land = "LEVEL4_LAND";
			gamma_kopno = 0;
			gamma_more = 0;
			break;
	case 5:
			sea = "LEVEL5_SEA";
			land = "LEVEL5_LAND";
			gamma_kopno = 0;
			gamma_more = 0;
			break;
	}

	graphics = load(land);
	for (h = 0; h < sirina_teksture_kopna; h++)
		for (w = 0; w < visina_teksture_kopna; w++)
			{
				kopno[w][h].r = getr(getpixel(graphics[0].dat, w, h)) + gamma_kopno;
				kopno[w][h].g = getg(getpixel(graphics[0].dat, w, h)) + gamma_kopno;
				kopno[w][h].b = getb(getpixel(graphics[0].dat, w, h)) + gamma_kopno;
			}
	unload(graphics);

	graphics = load(sea);
	for (h = 0; h < sirina_teksture_mora; h++)
		for (w = 0; w < visina_teksture_mora; w++)
			{
				more[w][h].r = getr(getpixel(graphics[0].dat, w, h)) + gamma_more;
				more[w][h].g = getg(getpixel(graphics[0].dat, w, h)) + gamma_more;
				more[w][h].b = getb(getpixel(graphics[0].dat, w, h)) + gamma_more;
			}
	unload(graphics);

	graphics = load("TEX1");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[5].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[5].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[5].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX2");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[6].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[6].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[6].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX5");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[0].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[0].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[0].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX6");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[1].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[1].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[1].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX7");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[2].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[2].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[2].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX8");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[3].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[3].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[3].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics = load("TEX9");
	for (h = 0; h < 20; h++)
		for (w = 0; w < 20; w++)
			{
				tekstura_tenka[4].r[w][h] = getr(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[4].g[w][h] = getg(getpixel(graphics[0].dat, w, h));
				tekstura_tenka[4].b[w][h] = getb(getpixel(graphics[0].dat, w, h));
			}
	unload(graphics);

	graphics =	load( "SHEALTH");
	blit(graphics[0].dat,small_health,0,0,0,0,15,15);
	unload(graphics);

	graphics =	load( "BHEALTH");
	blit(graphics[0].dat,big_health,0,0,0,0,20,20);
	unload(graphics);

	graphics =	load( "SHIELD");
	blit(graphics[0].dat,shield,0,0,0,0,12,12);
	unload(graphics);

	graphics =	load( "AP");
	blit(graphics[0].dat,ap,0,0,0,0,12,12);
	unload(graphics);

	graphics =	load( "MP");
	blit(graphics[0].dat,mp,0,0,0,0,12,12);
	unload(graphics);

	graphics =	load( "WEAPON");
	blit(graphics[0].dat,weapon,0,0,0,0,20,20);
	unload(graphics);

	graphics =	load( "INTERFACE");
	blit(graphics[0].dat, slika_suc, 0, 0, 0, 0, 640, 60);
	unload(graphics);
}

void
crtaj_nebo (int startx, int endx)
{
	int w, h;

	switch (nivo) {
	case 1:
		graphics = load("LEVEL1_SKY");
		break;
	case 2:
		graphics = load("LEVEL2_SKY");
		break;
	case 3:
		graphics = load("LEVEL3_SKY");
		break;
	case 4:
		graphics = load("LEVEL4_SKY");
		break;
	case 5:
		graphics = load("LEVEL5_SKY");
		break;
	}
	acquire_bitmap(aktivni);
  
	for (h = 0; h < 150; h++)
		for (w = 0; w < 640; w++)
			{
				if (w >= startx && w < endx)
					putpixel(aktivni, w,h,
									 makecol(
													 getr(getpixel(graphics[0].dat, w, h)),
													 getg(getpixel(graphics[0].dat, w, h)),
													 getb(getpixel(graphics[0].dat, w, h))));
        
			}
	release_bitmap(aktivni);
}

void
snimi_sliku ()
{
  FILE *dat;
  int w, h;
  int r = 0, g = 0, b = 0;

  aktivni = pogled;
  
  blit(aktivni, za_monitor, 0,0,0,0,SCREEN_W,SCREEN_H);
  
  aktivni = za_monitor;
  
  crtaj_tenk (-1);
  dat = fopen ("sshot.raw", "wb");
  for (h = 0; h < 480; h++)
    for (w = 0; w < 640; w++)
			{
				putpixel(aktivni, w ,h, makecol(r,g,b));
          
				fputc (r, dat);
				fputc (g, dat);
				fputc (b, dat);
			}
  fclose (dat);
}

void
snimi_kartu ()
{
  FILE *dat;
  int w, h;

  dat = fopen ("karta.raw", "w");

  for (h = 0; h < 640; h++)
    for (w = 0; w < 640; w++)
      fputc (reljef[w][h].vis + 55, dat);

  fclose (dat);
}
