/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Robert Avilov <ravilov@linux.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 */

#include "si3d.h"

void
crtaj_poklon (int koji)
{
  double xp, yp, zp;
  int flag;

  xp = poklon[koji].x;
  yp = poklon[koji].y;
  zp = reljef[(int) poklon[koji].x][(int) poklon[koji].y].vis;
  flag = 1;

  do
		{
			yp++;
			zp += 0.5;
			if (reljef[(int) xp][(int) yp].vis > zp)
				flag = 0;
		}
  while (yp < 640);

  if (flag == 1)
		{
			if (poklon[koji].vrsta == 1)
				masked_blit (small_health, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 15, 15);
                         
			if (poklon[koji].vrsta == 2)
				masked_blit (big_health, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 20, 20);
          
			if (poklon[koji].vrsta == 3)
				masked_blit (shield, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 12, 20);
          
			if (poklon[koji].vrsta == 4)
				masked_blit (ap, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 12, 12);
          
			if (poklon[koji].vrsta == 5)
				masked_blit (mp, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 12, 12);

			if (poklon[koji].vrsta == 6)
				masked_blit (weapon, aktivni,0,0,poklon[koji].x,
										 (int) (150 -
														reljef[poklon[koji].x][poklon[koji].y].vis +
														poklon[koji].y / 2), 20, 20);
                   
		}
}

void
iscrtaj_reljef (int dio, int x_start, int x_end, int y_start, int y_end)
{
  int w, h;
  int x, y=0, y_donji;
  int w_tex, h_tex;
  int br;
  int r = 0, g = 0, b = 0;
  int sjena;
	double x_svjetlost, y_svjetlost;

		//////////////////////////////////////////

		debug_message("draw landscape - begin");

  if (x_start == 0 && y_start == 0)
    kut_svjetlosti += PI / 180;

  x_svjetlost = cos (kut_svjetlosti) * 6;
  y_svjetlost = sin (kut_svjetlosti) * 6;

  if (dio == 0)
		{
			aktivni = monitor;
			boja_fonta = makecol(255,255,255);
			textprintf(aktivni, font, 165, 430, boja_fonta, "-DRAWING");
		}

	aktivni = pogled;
  if (dio != 2 && dio != 3)
		clear(aktivni);
  acquire_bitmap(aktivni);
  
  crtaj_nebo (x_start, x_end);

  for (h = y_start; h < y_end; h++)
    for (w = x_start; w < x_end; w++)
			{
				if (reljef[w][h].vis > 0)
					{
						sjena =
							50 +
							(reljef[(int) (w - x_svjetlost)][(int) (h - y_svjetlost)].vis -
							 reljef[(int) (w + x_svjetlost)][(int) (h + y_svjetlost)].vis) *
							3;
						w_tex = w;
						while (w_tex > sirina_teksture_kopna - 1)
							w_tex -= sirina_teksture_kopna;
						h_tex = h;
						while (h_tex > visina_teksture_kopna - 1)
							h_tex -= visina_teksture_kopna;
						r = kopno[w_tex][h_tex].r + sjena - reljef[w][h].sjena;
						g = kopno[w_tex][h_tex].g + sjena - reljef[w][h].sjena;
						b = kopno[w_tex][h_tex].b + sjena - reljef[w][h].sjena;
						if (r > 255) {
							r = 255;
						} else if (r < 0) {
							r = 0;
						}
						if (g > 255) {
							g = 255;
						} else if (g < 0) {
							g = 0;
						}
						if (b > 255) {
							b = 255;
						} else if (b < 0) {
							b = 0;
						}
					} else 
						{
							w_tex = w;
							while (w_tex > sirina_teksture_mora - 1)
								w_tex -= sirina_teksture_mora;
							h_tex = h;
							while (h_tex > visina_teksture_mora - 1)
								h_tex -= visina_teksture_mora;
							r = more[w_tex][h_tex].r + reljef[w][h].vis - 50;
							g = more[w_tex][h_tex].g + reljef[w][h].vis - 50;
							b = more[w_tex][h_tex].b + reljef[w][h].vis - 50;
							if (r < 0) {
								r = 0;
							} else if (r > 255) {
								r = 255;
							}
							if (g < 0) {
								g = 0;
							} else if (g > 255) {
								g = 255;
							}
							if (b < 0) {
								b = 0;
							} else if (b > 255) {
								b = 255;
							}
						}
				x = w;
				if (reljef[w][h].vis > 0) {
					y = 150 - reljef[w][h].vis + h / 2;
				} else {
					y = 150 + h / 2;
				}
				if (y > 0 && y < 470)
					{
						y_donji = y + 30;
						if (y_donji > 470)
							y_donji = 470;
						if (h < 639) {
							if (reljef[w][h+1].vis < reljef[w][h].vis) {
								vline(aktivni, x, y, y+30, makecol(r,g,b));
							} else {
								putpixel(aktivni, x ,y, makecol(r,g,b));
							}
						} else {
								vline(aktivni, x, y, y+30, makecol(r,g,b));
						}
					}
        
			}
    
	//////////////////////////////////////////////////////////////

	debug_message("draw landscape - end");

	aktivni = pogled;
  for (br = 0; br < broj_igraca; br++)
    if (br != igrac)
      crtaj_tenk (br);
  for (br = 0; br < broj_poklona; br++)
    crtaj_poklon (br);
  release_bitmap(aktivni);
  blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	aktivni = za_monitor;
  crtaj_tenk (igrac);
  
	blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  
}

void
crtaj_stranicu_tenka (double x_poz, double y_poz, double a1, double a2,
											double b1, double b2, double c1, double c2, int boja, int broj)
{
  double i, j, start_i, start_j, start_i_pomak, start_j_pomak, i_pomak,
    j_pomak;
  int br, br1;
  int rezolucija;
  int r = 0, g = 0, b = 0;
  double normala_z, svjetlo;

  normala_z = (b1 - a1) * (c2 - a2) - (b2 - a2) * (c1 - a1);
  if (normala_z > 0)
		{
			rezolucija = 20;
			start_i = a1;
			start_j = a2;
			i_pomak = (b1 - a1) / rezolucija;
			j_pomak = (b2 - a2) / rezolucija;
			start_i_pomak = (c1 - a1) / rezolucija;
			start_j_pomak = (c2 - a2) / rezolucija;

			svjetlo = normala_z / 3;

			for (br = 0; br < rezolucija; br++)
				{
					i = start_i;
					j = start_j;

					for (br1 = 0; br1 < rezolucija; br1++)
						{
							if (boja == 0) /* Top */
								{
									int broj2;

									broj2 = tenk[broj].broj;
									r = tekstura_tenka[broj2].r[br1][br];
									g = tekstura_tenka[broj2].g[br1][br];
									b = tekstura_tenka[broj2].b[br1][br];

									/* Another method, which sets the whole texture to the tank's color code.
										 r = tenk[broj].r;
										 g = tenk[broj].g;	
										 b = tenk[broj].b;*/
								}
							if (boja == 1) /* Left */
								{
									r = tekstura_tenka[5].r[br1][br];
									g = tekstura_tenka[5].g[br1][br];
									b = tekstura_tenka[5].b[br1][br];
								}
							if (boja == 2) /* Front */
								{
									r = tekstura_tenka[6].r[br1][br];
									g = tekstura_tenka[6].g[br1][br];
									b = tekstura_tenka[6].b[br1][br];
								}
							if (boja == 3) /* Right */
								{
									r = tekstura_tenka[5].r[19 - br1][br];
									g = tekstura_tenka[5].g[19 - br1][br];
									b = tekstura_tenka[5].b[19 - br1][br];
								}
							if (boja == 4) /* Rear */
								{
									r = tekstura_tenka[6].r[19 - br1][br];
									g = tekstura_tenka[6].g[19 - br1][br];
									b = tekstura_tenka[6].b[19 - br1][br];
								}
							if (boja == 5) /* Turret */
								{
									r = tekstura_tenka[4].r[br1][br];
									g = tekstura_tenka[4].g[br1][br];
									b = tekstura_tenka[4].b[br1][br];
								}
							r += svjetlo;
							g += svjetlo;
							b += svjetlo;
							if (r > 255)
								r = 255;
							if (g > 255)
								g = 255;
							if (b > 255)
								b = 255;

							/* Paint the tank in gray if it's dead. */
							if (tenk[broj].energija < 1)
								{
									int avg;

									avg = (r + g + b) / 3;
									r = g = b = avg;
								}

							putpixel(aktivni,x_poz + i, y_poz - j, makecol(r,g,b));
							i += i_pomak;
							j += j_pomak;
						}
					start_i += start_i_pomak;
					start_j += start_j_pomak;
				}
		}
}

void
crtaj_tenk (int koji)
{
  double x, y, z;
  int flag, br, broj;
  double x_kon[18];
  double y_kon[18];
  double z_kon[18];
  double x_pom[18];
  double y_pom[18];
  double z_pom[18];
  double visina1, visina2;
  double x_kut = 0, y_kut = 0, z_kut = 0;
  double z_pomak;
  int broj_tocaka;
  int pocetni_tenk, zavrsni_tenk;

  pocetni_tenk = koji;
  zavrsni_tenk = koji + 1;
  if (koji == -1)
		{
			pocetni_tenk = 0;
			zavrsni_tenk = broj_igraca;
		}
  for (broj = pocetni_tenk; broj < zavrsni_tenk; broj++)
		{

			{
				broj_tocaka = 18;
				x_kon[0] = -10;
				x_kon[1] = 10;
				x_kon[2] = 10;
				x_kon[3] = -10;
				x_kon[4] = -10;
				x_kon[5] = 10;
				x_kon[6] = 10;
				x_kon[7] = -10;
				x_kon[8] = -8;
				x_kon[9] = 3;
				x_kon[10] = 3;
				x_kon[11] = -8;
				x_kon[12] = -8;
				x_kon[13] = 3;
				x_kon[14] = 3;
				x_kon[15] = -8;
				x_kon[16] = -3;
				x_kon[17] = -3 + sin (tenk[broj].kut_cijevi) * 12;

				z_kon[0] = 4;
				z_kon[1] = 4;
				z_kon[2] = 4;
				z_kon[3] = 4;
				z_kon[4] = -3;
				z_kon[5] = -3;
				z_kon[6] = -3;
				z_kon[7] = -3;
				z_kon[8] = 6;
				z_kon[9] = 6;
				z_kon[10] = 6;
				z_kon[11] = 6;
				z_kon[12] = 4;
				z_kon[13] = 4;
				z_kon[14] = 4;
				z_kon[15] = 4;
				z_kon[16] = 6;
				z_kon[17] = 6 + cos (tenk[broj].kut_cijevi) * 12;

				y_kon[0] = -6;
				y_kon[1] = -6;
				y_kon[2] = 6;
				y_kon[3] = 6;
				y_kon[4] = -6;
				y_kon[5] = -6;
				y_kon[6] = 6;
				y_kon[7] = 6;
				y_kon[8] = -5;
				y_kon[9] = -5;
				y_kon[10] = 5;
				y_kon[11] = 5;
				y_kon[12] = -5;
				y_kon[13] = -5;
				y_kon[14] = 5;
				y_kon[15] = 5;
				y_kon[16] = 0;
				y_kon[17] = 0;


				z_kut = -tenk[broj].kut;

				for (br = 0; br < broj_tocaka; br++)
					{
						x_pom[br] = x_kon[br] * cos (z_kut) - y_kon[br] * sin (z_kut);
						y_pom[br] = y_kon[br] * cos (z_kut) + x_kon[br] * sin (z_kut);
						x_kon[br] = x_pom[br];
						y_kon[br] = y_pom[br];
					}

				visina1 = reljef[(int) (tenk[broj].x - 10)][(int) (tenk[broj].y)].vis;
				visina2 = reljef[(int) (tenk[broj].x + 10)][(int) (tenk[broj].y)].vis;
				z_pomak = visina2 - visina1;
				y_kut = atan (z_pomak / 20);

				visina1 = reljef[(int) (tenk[broj].x)][(int) (tenk[broj].y - 10)].vis;
				visina2 = reljef[(int) (tenk[broj].x)][(int) (tenk[broj].y + 10)].vis;
				z_pomak = visina2 - visina1;
				z_kut = atan (z_pomak / 20);

				x_kut = 0;

				for (br = 0; br < broj_tocaka; br++)
					{
						x_pom[br] =
							x_kon[br] * (sin (y_kut) * sin (z_kut) * sin (x_kut) +
													 cos (y_kut) * cos (x_kut)) +
							y_kon[br] * (cos (z_kut) * sin (x_kut)) +
							z_kon[br] * (cos (y_kut) * sin (z_kut) * sin (x_kut) -
													 cos (x_kut) * sin (y_kut));
						y_pom[br] =
							x_kon[br] * (cos (x_kut) * sin (y_kut) * sin (z_kut) -
													 cos (y_kut) * sin (x_kut)) +
							y_kon[br] * (cos (z_kut) * cos (x_kut)) +
							z_kon[br] * (cos (y_kut) * cos (x_kut) * sin (z_kut) +
													 sin (y_kut) * sin (x_kut));
						z_pom[br] =
							x_kon[br] * (cos (z_kut) * sin (y_kut)) +
							y_kon[br] * (-sin (z_kut)) +
							z_kon[br] * (cos (y_kut) * cos (z_kut));
					}

				tenk[broj].z = reljef[(int) tenk[broj].x][(int) tenk[broj].y].vis;

				tenk[broj].x_pomak = (x_pom[17] - x_pom[16]) / 12;
				tenk[broj].y_pomak = -(y_pom[17] - y_pom[16]) / 12;
				tenk[broj].z_pomak = (z_pom[17] - z_pom[16]) / 12;

				x_kut = 20 * PI / 180;
				for (br = 0; br < broj_tocaka; br++)
					{
						y_pom[br] = y_pom[br] * cos (x_kut) - z_pom[br] * sin (x_kut);
						z_pom[br] = z_pom[br] * cos (x_kut) + y_pom[br] * sin (x_kut);
					}
				tenk[broj].x_projektil = x_pom[17] * 1.3;
				tenk[broj].y_projektil = -y_pom[17] * 1.3;
				tenk[broj].z_projektil = z_pom[17] * 1.3;

				///////////////////////////////////////////////////////////

				x = tenk[broj].x;
				y = tenk[broj].y;
				z = tenk[broj].z + 3;
				flag = 1;


				do
					{
						y++;
						z += 0.5;
						if (reljef[(int) x][(int) y].vis > z)
							flag = 0;
					}
				while (y < 640);

				x = tenk[broj].x;
				y = 150 - tenk[broj].z + tenk[broj].y / 2;
				if (tenk[broj].z <= 0)
					flag = 0;

				if (flag == 1)
					{
						crtaj_stranicu_tenka (x, y, x_pom[3], z_pom[3], x_pom[2],
																	z_pom[2], x_pom[7], z_pom[7], 1, broj);
						crtaj_stranicu_tenka (x, y, x_pom[2], z_pom[2], x_pom[1],
																	z_pom[1], x_pom[6], z_pom[6], 2, broj);
						crtaj_stranicu_tenka (x, y, x_pom[1], z_pom[1], x_pom[0],
																	z_pom[0], x_pom[5], z_pom[5], 3, broj);
						crtaj_stranicu_tenka (x, y, x_pom[0], z_pom[0], x_pom[3],
																	z_pom[3], x_pom[4], z_pom[4], 4, broj);
						crtaj_stranicu_tenka (x, y, x_pom[0], z_pom[0], x_pom[1],
																	z_pom[1], x_pom[3], z_pom[3], 0, broj);

						crtaj_stranicu_tenka (x, y, x_pom[11], z_pom[11], x_pom[10],
																	z_pom[10], x_pom[15], z_pom[15], 5, broj);
						crtaj_stranicu_tenka (x, y, x_pom[10], z_pom[10], x_pom[9],
																	z_pom[9], x_pom[14], z_pom[14], 5, broj);
						crtaj_stranicu_tenka (x, y, x_pom[9], z_pom[9], x_pom[8],
																	z_pom[8], x_pom[13], z_pom[13], 5, broj);
						crtaj_stranicu_tenka (x, y, x_pom[8], z_pom[8], x_pom[11],
																	z_pom[11], x_pom[12], z_pom[12], 5, broj);
						crtaj_stranicu_tenka (x, y, x_pom[8], z_pom[8], x_pom[9],
																	z_pom[9], x_pom[11], z_pom[11], 5, broj);

						line(aktivni,x + x_pom[16], y - z_pom[16], x + x_pom[17],
								 y - z_pom[17], makecol(0,0,0) );
						line(aktivni,x + x_pom[16] + 1, y - z_pom[16], x + x_pom[17] + 1,
								 y - z_pom[17], makecol(0,0,0) );
					}
				if (flag == 0)
					{
						line (aktivni,x + x_pom[0], y - z_pom[0], x + x_pom[1], y - z_pom[1],
									makecol(0, 200, 0));
						line (aktivni,x + x_pom[1], y - z_pom[1], x + x_pom[2], y - z_pom[2],
									makecol (0, 200, 0));
						line (aktivni,x + x_pom[2], y - z_pom[2], x + x_pom[3], y - z_pom[3],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[3], y - z_pom[3], x + x_pom[0], y - z_pom[0],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[4], y - z_pom[4], x + x_pom[5], y - z_pom[5],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[5], y - z_pom[5], x + x_pom[6], y - z_pom[6],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[6], y - z_pom[6], x + x_pom[7], y - z_pom[7],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[7], y - z_pom[7], x + x_pom[4], y - z_pom[4],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[0], y - z_pom[0], x + x_pom[4], y - z_pom[4],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[1], y - z_pom[1], x + x_pom[5], y - z_pom[5],
									makecol (0, 200, 0));
						line (aktivni,x + x_pom[2], y - z_pom[2], x + x_pom[6], y - z_pom[6],
									makecol (0, 200, 0));
						line (aktivni,x + x_pom[3], y - z_pom[3], x + x_pom[7], y - z_pom[7],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[8], y - z_pom[8], x + x_pom[9], y - z_pom[9],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[9], y - z_pom[9], x + x_pom[10], y - z_pom[10],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[10], y - z_pom[10], x + x_pom[11],
									y - z_pom[11], makecol (0, 200, 0));
						line (aktivni, x + x_pom[11], y - z_pom[11], x + x_pom[8], y - z_pom[8],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[12], y - z_pom[12], x + x_pom[13],
									y - z_pom[13], makecol (0, 200, 0));
						line (aktivni, x + x_pom[13], y - z_pom[13], x + x_pom[14],
									y - z_pom[14], makecol (0, 200, 0));
						line (aktivni, x + x_pom[14], y - z_pom[14], x + x_pom[15],
									y - z_pom[15], makecol (0, 200, 0));
						line (aktivni, x + x_pom[15], y - z_pom[15], x + x_pom[12],
									y - z_pom[12], makecol (0, 200, 0));
						line (aktivni, x + x_pom[8], y - z_pom[8], x + x_pom[12], y - z_pom[12],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[9], y - z_pom[9], x + x_pom[13], y - z_pom[13],
									makecol (0, 200, 0));
						line (aktivni, x + x_pom[10], y - z_pom[10], x + x_pom[14],
									y - z_pom[14], makecol (0, 200, 0));
						line (aktivni, x + x_pom[11], y - z_pom[11], x + x_pom[15],
									y - z_pom[15], makecol (0, 200, 0));
						line (aktivni, x + x_pom[16], y - z_pom[16], x + x_pom[17],
									y - z_pom[17], makecol (0, 200, 0));
					}
			}
			if (broj_pogleda == 128)
				{
					x = tenk[broj].x * 0.75;
					y = tenk[broj].y * 0.75;
					putpixel (aktivni, 80 + x - 1, y - 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x - 1, y,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x - 1, y + 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x, y - 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x, y,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x, y + 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x + 1, y - 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x + 1, y,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
					putpixel (aktivni, 80 + x + 1, y + 1,
										makecol (tenk[broj].r, tenk[broj].g,
														 tenk[broj].b));
				}
		}
}
void
end_turn ()
{
  double promjena;

	aktivni = pogled;

  broj_turna++;

  do
		{
			igrac++;
			if (igrac > broj_igraca - 1)
				igrac = 0;
		}
  while (tenk[igrac].energija == 0);

  iscrtaj_reljef (3, tenk[igrac].x - 20, tenk[igrac].x + 20, 0, 640);

  if (broj_turna > broj_igraca)
    tenk[igrac].ap += 4;
  if (broj_turna <= broj_igraca)
    tenk[igrac].mp += 6;

  tenk[igrac].mp += 4;

  if ((broj_turna * 1.0 / (5 - broj_igraca)) ==
      ((int) broj_turna / (5 - broj_igraca))
      && broj_poklona < (broj_igraca * 3 - 1))
    baci_poklon ();

  if (promjena_vjetra == 1)
		{
			promjena = 2.0 * rand () / (RAND_MAX + 1.0) - 1.0;
			kut_vjetra += promjena;
		}

  ispisi_sucelje (0);
}

void
ma_daj_okreni (int kamo)
{
  struct
  {
    int vis;
  }
  priv_reljef[640][640];

  int br, br1;
  double priv;

	debug_message("begin of rotation");

  if (kamo == 1)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					priv_reljef[br1][639 - br].vis = reljef[br][br1].vis;
		}
  if (kamo == 2)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					priv_reljef[639 - br1][br].vis = reljef[br][br1].vis;
		}

  for (br = 0; br < 640; br++)
    for (br1 = 0; br1 < 640; br1++)
      reljef[br][br1].vis = priv_reljef[br][br1].vis;


  if (kamo == 1)
    for (br = 0; br < broj_igraca; br++)
			{
				priv = tenk[br].x;
				tenk[br].x = tenk[br].y;
				tenk[br].y = 639 - priv;
				tenk[br].kut -= PI / 2;
				if (tenk[igrac].kut < 0.02)
					tenk[igrac].kut = 2 * PI;
			}

  if (kamo == 2)
    for (br = 0; br < broj_igraca; br++)
			{
				priv = tenk[br].y;
				tenk[br].y = tenk[br].x;
				tenk[br].x = 639 - priv;
				tenk[br].kut += PI / 2;
				if (tenk[igrac].kut > 2 * PI)
					tenk[igrac].kut = 0;
			}

  if (kamo == 1)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					priv_reljef[br1][639 - br].vis = reljef[br][br1].sjena;
		}
  if (kamo == 2)
		{
			for (br = 0; br < 640; br++)
				for (br1 = 0; br1 < 640; br1++)
					priv_reljef[639 - br1][br].vis = reljef[br][br1].sjena;
		}

  for (br = 0; br < 640; br++)
    for (br1 = 0; br1 < 640; br1++)
      reljef[br][br1].sjena = priv_reljef[br][br1].vis;

  if (kamo == 1)
		{
			for (br = 0; br < broj_poklona; br++)
				{
					priv = poklon[br].x;
					poklon[br].x = poklon[br].y;
					poklon[br].y = 639 - priv;
				}
		}

  if (kamo == 2)
		{
			for (br = 0; br < broj_poklona; br++)
				{
					priv = poklon[br].x;
					poklon[br].x = 639 - poklon[br].y;
					poklon[br].y = priv;
				}
		}
  if (kamo == 1)
    kut_vjetra += 1.570796;
  if (kamo == 2)
    kut_vjetra -= 1.570796;
  ispisi_sucelje (1);

	debug_message("end of rotation");
}

void
end_round ()
{
  int br, br1;
	char *ime;
	int total[4] = {0, 0, 0, 0};
	char *team_names[4] = {"RED", "BLUE", "YELLOW", "GREEN"};

	aktivni = monitor;
	
  for (br = 0; br < broj_igraca; br++)
    if (tenk[br].energija > 0)
			break;

	for (br1 = 0; br1 < broj_igraca; br1++)
		total[tenk[br1].broj] += (int) tenk[br1].ukupna_steta;

	if (br == broj_igraca)
		ime = "NO";
	else
		{
			ime = team_names[br];
			tenk[br].broj_pobjeda++;
		}
			
	boja_fonta = makecol(255,255,255);
	textprintf(aktivni, font, 290, 230, boja_fonta, "END OF ROUND %i.", broj_runde);
	textprintf(aktivni, font, 290, 246, boja_fonta, "%s TEAM WINS!", ime);
	for (br = 0; br < 4; br++)
		if (total[br])
			textprintf(aktivni, font, 290, 265 + br * 15, boja_fonta, "%s TEAM TOTAL DAMAGE DONE: %i",
								 team_names[br], total[br]);
			
	readkey();

	aktivni = za_monitor;
	blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	aktivni = monitor;

  broj_runde++;
  if (broj_runde > max_broj_rundi)
		{
			textprintf(aktivni, font, 290, 230, boja_fonta, "GAME OVER!");

			total[0] = total[1] = total[2] = total[3] = 0;
			for (br1 = 0; br1 < broj_igraca; br1++)
				total[tenk[br1].broj] += (int) tenk[br1].broj_pobjeda;
		
			for (br = 0; br < 4; br++)
				if (total[br])
					textprintf(aktivni, font, 290, 250 + br1 * 15, boja_fonta,"%s TEAM: %i WINS",
										 team_names[br], total[br]);
		
			readkey();
			uvodni_izbor ();
			kontrola = 1;
		
			readkey();
		}
  else
		{
			data ();
			if (gen == 0)
				ucitaj_kartu (nivo);
			if (gen == 1)
				napravi_kartu ();
			ispisi_sucelje (1);
			aktivni = monitor;
			boja_fonta = makecol(20,20,20);
			for (br = 0; br < broj_igraca; br++)
				{
					boja_fonta = makecol(20,120,20);
					textprintf(aktivni, font,tenk[br].x - 15,120 - tenk[br].z + tenk[br].y / 2, boja_fonta,"%i",
										 (int) tenk[br].energija);

					if (igrac == br)
						circle(aktivni, 	tenk[br].x, 150 - tenk[br].z + tenk[br].y / 2, 30, makecol(100,100,100));
				}
			boja_fonta = makecol(20,20,20);
			textprintf(aktivni, font, 350, 230, boja_fonta,"%i %i", broj_runde, br + 1);
			for (br = 0; br < 10000; br++)
				for (br1 = 0; br1 < 5000; br1++);
		}
}
