/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Robert Avilov <ravilov@linux.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 */

#include "si3d.h"

void init_talk()
{
	FILE *fp;
	char *i;


	fp = myopen("talk.kil","rb");
	if (!fp) 
	{
		printf("err!\n");
		exit(EXIT_FAILURE);
	}
	fseek(fp,0L,SEEK_END);
	talk_buffer_kill_size = ftell(fp);
	fseek(fp,0L,SEEK_SET);
	talk_buffer_kill = (char*)malloc(talk_buffer_kill_size);
	if(!talk_buffer_kill)
	{
		printf("malloc err!\n");
		exit(EXIT_FAILURE);
	}

	debug_message("read talk.kil");
	fread(talk_buffer_kill,1,(int)talk_buffer_kill_size,fp);

	i = talk_buffer_kill;
	talk_kill_count=0;
	while(i<talk_buffer_kill+talk_buffer_kill_size)
	{
		if(*i=='\n') talk_kill_count++;
		i++;
	}

	fclose(fp);

	fp = myopen("talk.die","rb");
	if (!fp) 
	{
		printf("err!\n");
		exit(EXIT_FAILURE);
	}
	fseek(fp,0L,SEEK_END);
	talk_buffer_die_size = ftell(fp);
	fseek(fp,0L,SEEK_SET);
	talk_buffer_die = (char*)malloc(talk_buffer_die_size);
	if(!talk_buffer_die)
	{
		printf("malloc err!\n");
		exit(EXIT_FAILURE);
	}

	debug_message("read talk.die");
	fread(talk_buffer_die,1,(int)talk_buffer_die_size,fp);

	i = talk_buffer_die;
	talk_die_count=0;
	while(i<talk_buffer_die+talk_buffer_die_size)
	{
		if(*i=='\n') talk_die_count++;
		i++;
	}

	fclose(fp);

}

void talk(int what, int who)
{
	int r;
	char *b, *buffer, message[MAX_MESSAGE_SIZE];
	int i, size, count, col;
	time_t t;

	message[MAX_MESSAGE_SIZE - 1] = '\0';

	if(what==KILL){
		buffer = talk_buffer_kill;
		size = talk_buffer_kill_size;
		count = talk_kill_count;
	} else {
		buffer = talk_buffer_die;
		size = talk_buffer_die_size;
		count = talk_die_count;
	}

	time(&t);
	srand(t);
	r = rand() % count;
	b = buffer;
	i = 0;
	while((b<buffer+size)&&(i<r))
	{
		if(*b++=='\n') i++;
	}

	i = 0;
	while((b<buffer+size)&&(i<MAX_MESSAGE_SIZE))
	{
		message[i++] = *b++;
		if(*b=='\n')
		{
			message[i] = '\0';
			break;
		}
	}

	debug_message(message);

	text_mode (-1);
	col = makecol (0, 0, 0);
	if(tenk[who].x < 150)
	{
		textout(screen, font, message, tenk[who].x,16 + 150 - tenk[who].z + tenk[who].y / 2 , col);
	} else if (tenk[who].x > 490) {
		textout_right(screen, font, message, tenk[who].x,16 + 150 - tenk[who].z + tenk[who].y / 2 , col);
	} else {
		textout_centre(screen, font, message, tenk[who].x,16 + 150 - tenk[who].z + tenk[who].y / 2 , col);
	}
	text_mode (0);
	rest(SLEEP_TIME); /*sleep for SLEEP_TIME mil sec*/
}
